import java.util.Arrays;

/**
 * Diese Klasse Repräsentiert ein Genom.
 * 
 * Das Genom wird repräsentiert als Sequenz von den Zeichen
 * 'A', 'C', 'G' und 'T'. 
 *
 */
public class Genom {
    
    // Länge des Genomes
    private int length = 0;
    
    // Sequenz der Aminosäuren
    private char[] aminoAcids;

    // Das genutzte Alphabet
    static final char[] ALPHABET = {'A', 'C', 'G', 'T'};
    

    /**
     * Konstruiert ein Genom der angegebenen Länge. Dabei sollen die einzelnen
     * Zeichen zufällig aus dem Alphabet gewählt werden. 
     */
    public Genom(int length) {
        
        // Ihr Code kommt hierhin      
    }

  /**
     * Konstruiert ein Genom aus den in der aaSequence angegebenen Zeichen. 
     * Diese Methode wird hauptsächlich für Testzwecke genutzt
     */
    public Genom(char[] aminoAcids) {
        this.length = aminoAcids.length;
        this.aminoAcids = Arrays.copyOf(aminoAcids, aminoAcids.length);
    }

    /**
     * Erzeugt einen Klon der aktuellen Klasse. 
     * Diese Methode wird hauptsächlich für Testzwecke genutzt
     */
    public Genom clone() {
        return new Genom(this.aminoAcids);
    }


    /**
     * Gibt die Folge der Aminosäuren zurück
     */
    public char[] getAASequence() {
        return aminoAcids;
    }
    
    /**
     * Gibt die Länge  der repräsentierten Sequenz zurück.
     */
    public int getLength() { 
        return this.length;
    }

    /**
     * Gibt die Aminosäuresequenz als String zurück. Nutzen Sie dazu einen Stringbuffer.
     */
    public String toString() {
        
        // Ihr Code kommt hierhin       
        return "@";
    }
    
    public boolean equals(Object o) {
        return isEqual((Genom) o);
    }

    /**
     * Gibt true zurück falls das übergebene Genom gleich diesem Objekt ist. 
     */
    public boolean isEqual(Genom other) {

        // Ihr Code kommt hierhin   
        return true;  
    }
    
   
    
    /**
     * Mutiert eine zufällig Position in der Aminosäure-sequenz zu einem 
     * zufälligen Zeichen im Alphabet.
     */
    public void pointMutation() {
        // Ihr Code kommt hierhin    

        
    }
    
    /**
     * Fügt an einer zufälligen Stelle in der Aminosäure-sequenz ein 
     * zufälliges Zeichen ein.
     */
    public void insertion() {

        // Ihr Code kommt hierhin       
    }
    
    /**
     * Löscht an einer zufälligen Position ein Zeichen aus der Aminosäuresequenz. 
     */
    public void deletion() {


        // Ihr Code kommt hierhin
       
    }
    

    public static void main(String[] args) {
        // Hier können Sie eigene kleine Testprogramm 
        // hinschreiben um die Klasse zu testen .
    }
}
