
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;

import ch.unibas.informatik.jturtle.Turtle;

public class Snowflake {

  Turtle turtle = null;
  
  // Die maximale Rekursionstiefe 
  int depth = 0;

  // Länge der Kochkurve
  static final int LENGTH_OF_CURVE = 120;

  /**
   * Kreiert eine Schneeflocke mit angegebener maximaler Rekursionstiefe
  */
  Snowflake(int depth) {
    this.turtle = new Turtle();
    this.depth = depth;
  }

  /**
   * Setzt das Turtle auf die Startposition
   */
  void setStartPosition() {
    turtle.penUp();
    turtle.home();
    turtle.forward(LENGTH_OF_CURVE * 0.3 );
    turtle.turnRight(90);
    turtle.backward(LENGTH_OF_CURVE * 0.5);
    turtle.penDown();
  }

  /** 
   * Zeichnet die Kochkurve auf dem aktuellen Rekursionslevel. 
   * Das Argument length gibt an wie lange ein Liniensegment sein soll
   */
  void drawKochCurve(int currentDepth, double length) {
    // Ihr Code
  }


  /**
   * Zeichnet eine Scheeflocke, durch mehrmaliges zeichnen der Kochkurve
   */
  void drawSnowflake() {
    setStartPosition();
   
    // Ihr Code

  }


  /**
   * Speichert das gezeichnete Bild.
   */
  void saveImage(String filename) {
    BufferedImage image = turtle.toImage();

    try {
      ImageIO.write(image, "png", new File(filename));
    } catch (IOException e) {
      System.out.println(e.getMessage());
    }
  }

  /**
   * Testprogramm um Zeichnung mit verschiedenen Rekursionstiefen zu generieren. 
   */
  public static void main(String[] args) {

    // Führt das Programm für Rekursionstiefen 0 1 und 2 aus. 
    for (int i = 1; i <= 4; i++) {
      Snowflake flake = new Snowflake(i);
      flake.drawSnowflake();
      flake.saveImage("snowflake " + i + ".png");
    }
  }

}
