/**
 * Testprogramm um Ihre Simulation zu testen. 
 */
public class TestGeneticEvolution {

  /**
   * Tested wieviele Mutationen durchgeführt werden 
   * mÜssen bis ein bestimmtes Gen im Genpool ist.   
   */
  public static int mutateTo(GenePool pool, Genom species) {
     
      int years = 0;
      while (!pool.contains(species)) {
        pool.mutate();
                
        years += 1;
      }
      
      return years;
  }

  
  public static void main( String[] args ) {
    int len = 10;
    int poolSize = 1000;
    int years = 0;

    int numSimulationRuns = 2;

    System.out.println("An examplar human genom in our model is:\n" 
      +new Genom(len));
    System.out.println("An examplar small genpool in our model is:\n"
      +new GenePool(5,len));
    System.out.println("Starting simulation ...");
    for( int i = 0; i < numSimulationRuns; ++i) {
      
      Genom species = new Genom(len);
      GenePool pool = new GenePool(poolSize,len);      
      int year = mutateTo(pool,species);
      years += year;
    }
    System.out.println("Needed " +years / (double) numSimulationRuns +" in average.");
  }
}
