
import edu.illinois.cs.cs125.gradlegrader.annotations.Graded;
import edu.illinois.cs.cs125.gradlegrader.annotations.Tag;
import org.junit.Test;
import java.io.PrintStream;
import java.io.ByteArrayOutputStream;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertArrayEquals;
import static org.junit.Assert.assertTrue;
import static org.junit.Assert.assertFalse;

public class PriorityQueueTests {


    private void assertElementEquals(Element gt, Element e) {
        assertEquals(gt.getPriority(), e.getPriority());
        assertEquals(gt.getData(), e.getData());
    }

    @Test(timeout = 1000)
    @Graded(points = 1)
    @Tag(name = "difficulty", value = "simple")
    @Tag(name = "function", value = "basicSanityTest")
	public void basicSanityTest() {
       Element e = new Element(10, "hello");
       assertEquals(e.getPriority(), 10);
       assertEquals(e.getData(), "hello");

       PriorityQueue pq = new PriorityQueue();
       pq.put(e);
       Element restoredElement = pq.get();
       assertElementEquals(e, restoredElement);

       assertEquals(0, pq.length());
       
       pq.put(new Element(0, "a"));
       pq.put(new Element(1, "b"));
       assertEquals(2, pq.length());
       
	}

    @Test(timeout = 1000)
    @Graded(points = 2)
    @Tag(name = "difficulty", value = "simple")
    @Tag(name = "function", value = "putGetTest")
	public void methodPutGetTest() {

		PriorityQueue pq =new PriorityQueue();
		Element[] e= new Element[6];
		e[0] = new Element(7,"H");
		e[1] = new Element(4,"A");
		e[2] = new Element(3,"1b");
		e[3] = new Element(2,"xy");
		e[4] = new Element(1,"abc");
        e[5] = new Element(0,"99");
        
        pq.put(e[4]);
        pq.put(e[1]);
        pq.put(e[2]);
        pq.put(e[5]);
        pq.put(e[0]);
        pq.put(e[3]);

        // should come out sorted
        for (int i = 0; i < pq.length(); i++) {
            Element retrieved = pq.get();
            assertElementEquals(e[i], retrieved);
        }
	}

    @Test(timeout = 1000)
    @Graded(points = 1)
    @Tag(name = "difficulty", value = "simple")
    @Tag(name = "function", value = "toStringTest")
	public void toStringTest() {
        Element e = new Element(7, "hello");
        assertTrue(e.toString().contains("hello"));
        assertTrue(e.toString().replace(" ", "").contains("(7)"));

        PriorityQueue pq = new PriorityQueue();
        pq.put(new Element(3, "hello"));
        pq.put(new Element(7, "world"));
        String pqAsString = pq.toString().replace(" ", "");
        assertTrue(pqAsString.contains("hello"));
        assertTrue(pqAsString.contains("world"));
        assertTrue(pqAsString.contains("(7)"));
        assertTrue(pqAsString.contains("(3)"));
        assertFalse(pqAsString.endsWith(","));
	}

}
